from random import randint
from math import copysign
from drama import oscar

import pandas as pd
import numpy as np

defaultProjects = {
    "ECSS": "./solar_activity/ECSS.dpz",
    "MC6": "./solar_activity/MonteCarlo6.dpz",
    "MC5": "./solar_activity/MonteCarlo5.dpz",
    "MC4": "./solar_activity/MonteCarlo4.dpz",
    "MC3": "./solar_activity/MonteCarlo3.dpz",
    "MC2": "./solar_activity/MonteCarlo2.dpz",
    "Latest": "./solar_activity/LatestPrediction.dpz",
}

earths_radius = 6371  # [Km]

# ======= Functions =======

def zipSolverRuns(results: list, dataframe = None) -> pd.DataFrame:
    """ Processes the pyOSCAR output files and zips the relevant orbital information in a new pandas DataFrame, or an existing one if defined.
    
    ### Parameters
    results : {list}
        A list of pyOSCAR's output files.
    dataframe : {pd.DataFrame}, default = None
        A pandas DataFrame object for the zipped orbital information to be appended to.
    
    ### Returns
    dataframe : {float}
        A pandas DataFrame object with the zipped orbital information.
    """

    if dataframe == None:
        dataframe = pd.DataFrame()

    for simulation in results:
        stats = simulation["final_state"]

        stats["lifetime"] = simulation["lifetime"]

        stats["start"] = simulation["config"]["epoch"]
        stats["sma0"] = simulation["config"]["sma"]
        stats["ecc0"] = simulation["config"]["ecc"]
        stats["inc0"] = simulation["config"]["inc"]
        stats["raan0"] = simulation["config"]["raan"]
        stats["aop0"] = simulation["config"]["aop"]
        stats["ma0"] = simulation["config"]["ma"]
        stats["cross_section"] = simulation["config"]["cross_section"]
        stats["mass"] = simulation["config"]["mass"]
        stats["drag"] = simulation["config"]["drag_coefficient"]
        stats["reflectivity"] = simulation["config"]["reflectivity_coefficient"]
        stats["disposal_option"] = simulation["config"]["disposal_option"]

        dataframe = dataframe.append(stats, ignore_index = True)

    return dataframe

def getInclinationSSO(altitude: float) -> float:
    """ Calculates the inclination of an SSO orbit for a given altitude above Earth's surface. The
    result is rounded up to match pyOSCAR's favoured inclination precision.
    
    ### Parameters
    altitude : {float}
        The altitude of the SSO orbit.
    
    ### Returns
    inclination : {float}
        The inclination of the resulting SSO orbit.
    """
    inclination = np.degrees(np.arccos(-(((earths_radius + altitude) / 12352) ** 3.5)))
    
    # Round up the inclination to match pyOSCAR's input precision.
    return np.around(inclination, 3)

def runOrbitSimulationSSO(altitude: float, inputProject: str, config: list) -> list:
    """ A wrapper function that calls oscar.run() for the given project and an updated configuration dictionary
    for the variable altitude and the derived SSO inclination.
    
    ### Parameters
    altitude : {float}
        The altitude of the SSO orbit.
    inputProject : {str}
        The file path to the .dpz file generated by OSCAR which has the Solar and Geomagnetic input.
            If given "ECSS" or "MCN" (Where N is a number from 2-6) the Solar Model will be set to ECSS or Monte Carlo of N Circles respectively.
            If given "Latest" the solar model will extrapolate the 25th cycle data from January 6th 2021.
    config : {list}
        The configuration list of pyOSCAR with all other orbital elements apart from the SSO iterables and other OSCAR input.
    
    ### Returns
    pyOSCAR_results : {list}
        The results output of pyOSCAR's orbit propagation.
    """

    # Calculate the Semi-major axis and corresponding Inclination for the orbit.
    sma = earths_radius + altitude
    inc = getInclinationSSO(altitude)
    
    tempConfig = {**config, **{"sma": sma, "inc": inc}}

    result = oscar.run(config = tempConfig, project = inputProject)

    return result["results"][0]


def findAltitudeForLifetime(inputProject: str, basicConfig: list, startingAltitude: float = None,
                            goalLifetime: float = 25, accuracy: float = 1, silent: bool = False) -> list:
    """ A function that optimizes the altitude of SSO orbits using pyDRAMA to match the request lifetime of the satellite mission.
    Iterates through SSO altitudes to find the orbit that has a lifetime in the range [goalLifetime -accuracy/24, goalLifetime +accuracy/24].
    Returns a list with OSCAR results lists of all the iterated orbits.
    
    The algorithm will run for at least 3 times to ensure a minimum exploration of the parameter space before convergence.
    Optimization steps are injected with artificial randomness. #TODO: Make this an option.
    
    ### Parameters
    inputProject : {str}
        The file path to the .dpz file generated by OSCAR which has the Solar and Geomagnetic input.
            If given "ECSS" or "MCN" (Where N is a number from 2-6) the Solar Model will be set to ECSS or Monte Carlo of N Circles respectively.
            If given "Latest" the solar model will extrapolate the 25th cycle data from January 6th 2021.
    basicConfig : {list}
        The configuration list of pyOSCAR with all orbital elements apart from the SSO iterables and other OSCAR input.
    startingAltitude : {float}
        The altitude used to begin the search with. If omitted, a prediction will be taken by the algorithm (Suggested) # TODO: Not yet implemented.
    goalLifetime : {float}, default = 25 [years]
        The lifetime in years (with 5% margin per ISO 27852:2011) of the orbit that the algorithm optimizes the altitude for.
    accuracy : {float}, default = 1 [months]
        The total margin of the lifetime inside of which the algorithm terminates itself.
    silent : {bool}, default = False
        Controls the printing of step updates during optimization.
    
    ### Returns
    resultTable : {list}
        A list of pyOSCAR outputs for each tested altitudes in the optimization process.
    """

    resultTable = []

    altitude = startingAltitude
    if startingAltitude == None: # TODO Perform a better first estimate.
        # This fit is based on analysis for the AcubeSAT orbit, m = 4.940 kg, csection = 0.0113

        altitude = 44.9 *np.log(goalLifetime) +391.91

    inputProject = (defaultProjects[inputProject] if inputProject in defaultProjects else inputProject)

    # Run a simulation, save the results and calculate its lifetime.
    result = runOrbitSimulationSSO(altitude, inputProject, basicConfig)
    resultTable.append(result)
    lifetime = result["lifetime"]

    if not silent: print(f"First choice of {altitude} has yielded a lifetime of: {lifetime}")

    altitude_0 = altitude; lifetime_0 = lifetime
    # TODO: Can this prediction be stronger? Maybe use the previous fit?
    altitude += copysign(1, goalLifetime - lifetime) * randint(20, 60) / 100

    # Run a simulation, save the results and calculate its lifetime.
    result = runOrbitSimulationSSO(altitude, inputProject, basicConfig)
    resultTable.append(result)
    lifetime = result["lifetime"]

    haventConverged = True

    while haventConverged:
        if lifetime != lifetime_0:
            dx = (goalLifetime -lifetime) *(altitude -altitude_0) / (lifetime -lifetime_0)
        else:
            dx = 1
        
        # Remap the previous parameters and update altitude.
        altitude_0 = altitude; lifetime_0 = lifetime
        altitude += dx

        # Run a new simulation, save the results and calculate its lifetime.
        result = runOrbitSimulationSSO(altitude, inputProject, basicConfig)
        resultTable.append(result)
        lifetime = result["lifetime"]

        haventConverged = abs(lifetime - goalLifetime) > accuracy / 12

    return resultTable